library(RSNNS) 

library(ggplot2)
library(plyr)
library(nnet)
library(rpart)
library(tree)
library(AMORE)
#library(neuralnet)
#svm
library(e1071)

#定义网络输入 
#flag变量的下标
flag=which(names(B_train3)=="flag")
row=c(2:length(B_train3))
row=row[row!=flag]#去掉result列
B_train3_data= B_train3[,row]
B_train3_result=B_train3[,flag]

## kernlab包里的spam数据集，spam是一个邮件数据集，共有4601个观测值，58个变量
library(caret) 
library(kernlab)


training <- B_train3
testing <- spam[-inTrain, ]

#训练模型
modelFit <- train(flag~.,data=training,method="glm")
# train( )函数就是我们的训练器，type~是回归方程，data=training指定数据集，method="glm"指定具体的模型形式，这里我们用的是glm估计，当然读者也可以用SVM（支持向量机），nnet神经网络等其他模型形式
modelFit$finalModel

#验证模型
predictions <- predict(modelFit,newdata=testing)
head(predictions)####预测结果如下

##错误分类矩阵,将模型预测的值和真实的值进行比较，计算错误分类率。我们可知准确率为0.9184
confusionMatrix(predictions,testing$type)












#定义网络输出，并将数据进行格式转换 
B_trainTargets = decodeClassLabels(B_train3_result)
#从中划分出训练样本和检验样本 
iris = splitForTrainingAndTest(B_train3_data, B_trainTargets, ratio=0.15)
#数据标准化 
iris = normTrainingAndTestSet(iris)
#利用mlp命令执行前馈反向传播神经网络算法(多层感知器)
model = mlp(iris$inputsTrain, iris$targetsTrain, size=5, learnFunc="Quickprop", learnFuncParams=c(0.1, 2.0, 0.0001, 0.1),maxit=100, inputsTest=iris$inputsTest, targetsTest=iris$targetsTest) 
#利用上面建立的模型进行预测 
predictions = predict(model,iris$inputsTest)
#生成混淆矩阵，观察预测精度
confusionMatrix(iris$targetsTest,predictions)