## kernlab包里的spam数据集，spam是一个邮件数据集，共有4601个观测值，58个变量
library(caret) 
library(kernlab)
data(spam)
head(spam)

##数据划分createDataPartition
inTrain <- createDataPartition(y=spam$type,p=0.8,list=FALSE)
training <- spam[inTrain, ]
testing <- spam[-inTrain, ]


#训练模型
modelFit <- train(type~.,data=training,method="glm")
# train( )函数就是我们的训练器，type~是回归方程，data=training指定数据集，method="glm"指定具体的模型形式，这里我们用的是glm估计，当然读者也可以用SVM（支持向量机），nnet神经网络等其他模型形式
modelFit$finalModel

#验证模型
predictions <- predict(modelFit,newdata=testing)
head(predictions)####预测结果如下

##错误分类矩阵,将模型预测的值和真实的值进行比较，计算错误分类率。我们可知准确率为0.9184
confusionMatrix(predictions,testing$type)
